import es, playerlib, cfglib, os

config = cfglib.AddonCFG(es.getAddonPath("deathmatch") + "/rvb.cfg")
config.text("**************************")
config.text("   Downloads and Models   ")
config.text("**************************")
config.text("Default Settings")
config.text("Recommend You don't edit")
redvsblue_disable_downloads = config.cvar("redvsblue_disable_downloads",   0, "Change to 1 if you are using fast downloads or mani")
redvsblue_redmodel_folder   = config.cvar("redmodel_folder",   'models/player/bic/', "Ct model path used for downloads")
redvsblue_bluemodel_folder   = config.cvar("bluemodel_folder",   'models/player/bic/', "T's Model path used for downloads")
redvsblue_red_model   = config.cvar("redvsblue_red_model",   'models/player/bic/t_arctic.mdl', "Terriost Model")
redvsblue_blue_model   = config.cvar("redvsblue_blue_model",   'models/player/bic/ct_sas.mdl', "Ct Model")
config.text("**************************")
config.text("         Extra's          ")
config.text("**************************")
redvsblue_pushscale = config.cvar("redvsblue_pushscale",   400, "Makes Ragdolls fly")
redvsblue_energyhe = config.cvar("redvsblue_energyhe",   1, "Hegrenades will be like the energy grenades in halo")

config.write()

# ======================#
#         PUBLIC
# ======================#
info = es.AddonInfo()
info.name     = "Red Vs Blue"
info.version  = "2.5"
info.url      = "None"
info.basename = "sic_rvb"
info.author   = "sicman_adrian"
es.ServerVar('sic_rvb', info.version, info.name).makepublic()

# ======================#
#     MODELS&MATERIALS
# ======================#
# Thanks to bonbon for all the downloads ables help
model_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + str(redvsblue_redmodel_folder)
model_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + str(redvsblue_bluemodel_folder)
material_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/player/bic/redmc/'
material_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/player/bic/bluemc/'


def load():
    es.server.queuecmd('phys_pushscale %s' % redvsblue_pushscale)
    config.execute()
    if redvsblue_energyhe:
        es.addons.registerTickListener(TickListener)
    if not redvsblue_disable_downloads:
        downloadskins()

def unload():
    if redvsblue_energyhe:
        es.addons.unregisterTickListener(TickListener)

def es_map_start(ev):
    if not redvsblue_disable_downloads:
        downloadskins()


def downloadskins():
    for dlfile in os.listdir(model_folder1):
        es.stringtable('downloadables', model_folder1 + dlfile)
    for dlfile in os.listdir(model_folder2):
        es.stringtable('downloadables', model_folder2 + dlfile)
    for dlfile in os.listdir(material_folder1):
        es.stringtable('downloadables', material_folder1 + dlfile)
    for dlfile in os.listdir(material_folder2):
        es.stringtable('downloadables', material_folder2 + dlfile)

def round_start(ev):
    es.server.queuecmd('phys_pushscale %s' % redvsblue_pushscale)

def player_spawn(ev):
    player = playerlib.getPlayer(ev['userid'])
    if ev['es_userteam'] == '2':
        player.set('model', str(redvsblue_red_model))
    elif ev['es_userteam'] == '3':
          player.set('model', str(redvsblue_blue_model))

def TickListener():
    for index in es.createentitylist('hegrenade_projectile'):
        location = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
        es.effect("energysplash", location, location, 0)